package de.ozgcloud.xta.test.app.mapper;

import de.ozgcloud.xta.test.app.model.XtaCloseRequest;
import de.ozgcloud.xta.test.app.model.XtaFile;
import de.ozgcloud.xta.test.app.model.XtaGetMessageRequest;
import de.ozgcloud.xta.test.app.model.XtaGetTransportReportRequest;
import de.ozgcloud.xta.test.app.model.XtaIdentifier;
import de.ozgcloud.xta.test.app.model.XtaLookupServiceRequest;
import de.ozgcloud.xta.test.app.model.XtaMessage;
import de.ozgcloud.xta.test.app.model.XtaMessageMetaData;
import de.ozgcloud.xta.test.app.model.XtaMessageMetaDataListingRequest;
import genv3.de.xoev.transport.xta.x211.ContentType;
import genv3.de.xoev.transport.xta.x211.GenericContentContainer;
import genv3.de.xoev.transport.xta.x211.LookupServiceRequest;
import genv3.de.xoev.transport.xta.x211.LookupServiceType;
import genv3.eu.osci.ws.x2008.x05.transport.MsgBoxCloseRequestType;
import genv3.eu.osci.ws.x2008.x05.transport.MsgBoxFetchRequest;
import genv3.eu.osci.ws.x2008.x05.transport.MsgBoxStatusListRequestType;
import genv3.eu.osci.ws.x2008.x05.transport.MsgSelector;
import genv3.eu.osci.ws.x2014.x10.transport.DestinationsType;
import genv3.eu.osci.ws.x2014.x10.transport.KeyCodeType;
import genv3.eu.osci.ws.x2014.x10.transport.MessageMetaData;
import genv3.eu.osci.ws.x2014.x10.transport.MsgIdentificationType;
import genv3.eu.osci.ws.x2014.x10.transport.OriginatorsType;
import genv3.eu.osci.ws.x2014.x10.transport.PartyIdentifierType;
import genv3.eu.osci.ws.x2014.x10.transport.PartyType;
import genv3.eu.osci.ws.x2014.x10.transport.QualifierType;
import java.util.ArrayList;
import java.util.List;
import javax.annotation.processing.Generated;
import org.apache.cxf.ws.addressing.AttributedURIType;
import org.springframework.stereotype.Component;

@Generated(
    value = "org.mapstruct.ap.MappingProcessor",
    date = "2025-04-04T11:28:08+0000",
    comments = "version: 1.6.0, compiler: javac, environment: Java 21.0.6 (Eclipse Adoptium)"
)
@Component
public class RequestMapperImpl implements RequestMapper {

    @Override
    public XtaMessage mapXtaMessageFromGenericContentContainer(GenericContentContainer genericContainer, MessageMetaData messageMetaData) {
        if ( genericContainer == null && messageMetaData == null ) {
            return null;
        }

        XtaMessage.XtaMessageBuilder xtaMessage = XtaMessage.builder();

        if ( genericContainer != null ) {
            xtaMessage.messageFile( mapXtaFileFromContentType( genericContainerContentContainerMessage( genericContainer ) ) );
            List<ContentType> attachment = genericContainerContentContainerAttachment( genericContainer );
            xtaMessage.attachmentFiles( contentTypeListToXtaFileList( attachment ) );
        }
        xtaMessage.metaData( mapXtaMessageMetaData( messageMetaData ) );

        return xtaMessage.build();
    }

    @Override
    public XtaMessageMetaData mapXtaMessageMetaData(MessageMetaData messageMetaData) {
        if ( messageMetaData == null ) {
            return null;
        }

        XtaMessageMetaData.XtaMessageMetaDataBuilder xtaMessageMetaData = XtaMessageMetaData.builder();

        xtaMessageMetaData.service( messageMetaDataQualifierService( messageMetaData ) );
        xtaMessageMetaData.businessScenarioCode( mapBusinessScenarioCode( messageMetaDataQualifierBusinessScenario( messageMetaData ) ) );
        xtaMessageMetaData.businessScenarioName( messageMetaDataQualifierBusinessScenarioDefinedName( messageMetaData ) );
        xtaMessageMetaData.businessScenarioListUri( messageMetaDataQualifierBusinessScenarioDefinedListURI( messageMetaData ) );
        xtaMessageMetaData.businessScenarioListVersionId( messageMetaDataQualifierBusinessScenarioDefinedListVersionID( messageMetaData ) );
        xtaMessageMetaData.messageTypeCode( messageMetaDataQualifierMessageTypeCode( messageMetaData ) );
        xtaMessageMetaData.messageTypePayloadSchema( messageMetaDataQualifierMessageTypePayloadSchema( messageMetaData ) );
        xtaMessageMetaData.messageId( messageMetaDataMsgIdentificationMessageIDValue( messageMetaData ) );
        xtaMessageMetaData.authorIdentifier( mapXtaIdentifier( messageMetaDataOriginatorsAuthorIdentifier( messageMetaData ) ) );
        xtaMessageMetaData.readerIdentifier( mapXtaIdentifier( messageMetaDataDestinationsReaderIdentifier( messageMetaData ) ) );
        xtaMessageMetaData.messageSize( messageMetaData.getMsgSize() );

        return xtaMessageMetaData.build();
    }

    @Override
    public XtaFile mapXtaFileFromContentType(ContentType contentType) {
        if ( contentType == null ) {
            return null;
        }

        XtaFile.XtaFileBuilder xtaFile = XtaFile.builder();

        xtaFile.file( persistToTempFile( contentType.getValue() ) );
        xtaFile.name( contentType.getFilename() );
        xtaFile.language( contentType.getLang() );
        xtaFile.contentType( contentType.getContentType() );
        xtaFile.contentDescription( contentType.getContentDescription() );
        xtaFile.encoding( contentType.getEncoding() );
        xtaFile.id( contentType.getId() );
        xtaFile.size( contentType.getSize() );

        return xtaFile.build();
    }

    @Override
    public XtaMessageMetaDataListingRequest mapMessageMetaDataListingRequest(MsgBoxStatusListRequestType fetchRequest, PartyType clientIdentifier) {
        if ( fetchRequest == null && clientIdentifier == null ) {
            return null;
        }

        XtaMessageMetaDataListingRequest.XtaMessageMetaDataListingRequestBuilder xtaMessageMetaDataListingRequest = XtaMessageMetaDataListingRequest.builder();

        if ( fetchRequest != null ) {
            if ( fetchRequest.getMaxListItems() != null ) {
                xtaMessageMetaDataListingRequest.maxListItems( fetchRequest.getMaxListItems().intValue() );
            }
        }
        if ( clientIdentifier != null ) {
            xtaMessageMetaDataListingRequest.clientIdentifier( mapXtaIdentifier( clientIdentifier.getIdentifier() ) );
        }

        return xtaMessageMetaDataListingRequest.build();
    }

    @Override
    public XtaIdentifier mapXtaIdentifier(PartyIdentifierType partyType) {
        if ( partyType == null ) {
            return null;
        }

        XtaIdentifier.XtaIdentifierBuilder xtaIdentifier = XtaIdentifier.builder();

        xtaIdentifier.name( partyType.getName() );
        xtaIdentifier.category( partyType.getCategory() );
        xtaIdentifier.value( partyType.getValue() );

        return xtaIdentifier.build();
    }

    @Override
    public XtaCloseRequest mapXtaCloseRequest(MsgBoxCloseRequestType closeRequest, PartyType authorIdentifier) {
        if ( closeRequest == null && authorIdentifier == null ) {
            return null;
        }

        XtaCloseRequest.XtaCloseRequestBuilder xtaCloseRequest = XtaCloseRequest.builder();

        if ( closeRequest != null ) {
            xtaCloseRequest.messageId( closeRequestLastMsgReceivedFirstValue( closeRequest ) );
        }
        if ( authorIdentifier != null ) {
            xtaCloseRequest.clientIdentifier( mapXtaIdentifier( authorIdentifier.getIdentifier() ) );
        }

        return xtaCloseRequest.build();
    }

    @Override
    public XtaGetMessageRequest mapXtaGetMessageRequest(MsgBoxFetchRequest fetchRequest, PartyType authorIdentifier) {
        if ( fetchRequest == null && authorIdentifier == null ) {
            return null;
        }

        XtaGetMessageRequest.XtaGetMessageRequestBuilder xtaGetMessageRequest = XtaGetMessageRequest.builder();

        if ( fetchRequest != null ) {
            xtaGetMessageRequest.messageId( fetchRequestMsgSelectorMessageIDFirstValue( fetchRequest ) );
        }
        if ( authorIdentifier != null ) {
            xtaGetMessageRequest.clientIdentifier( mapXtaIdentifier( authorIdentifier.getIdentifier() ) );
        }

        return xtaGetMessageRequest.build();
    }

    @Override
    public XtaLookupServiceRequest mapXtaLookupServiceRequest(LookupServiceRequest lookupServiceRequest, PartyType authorIdentifier) {
        if ( lookupServiceRequest == null && authorIdentifier == null ) {
            return null;
        }

        XtaLookupServiceRequest.XtaLookupServiceRequestBuilder xtaLookupServiceRequest = XtaLookupServiceRequest.builder();

        if ( lookupServiceRequest != null ) {
            xtaLookupServiceRequest.service( lookupServiceRequestLookupServiceRequestListFirstLookupServiceServiceType( lookupServiceRequest ) );
            xtaLookupServiceRequest.readerIdentifier( mapXtaIdentifier( lookupServiceRequestLookupServiceRequestListFirstLookupServiceReaderIdentifier( lookupServiceRequest ) ) );
        }
        if ( authorIdentifier != null ) {
            xtaLookupServiceRequest.authorIdentifier( mapXtaIdentifier( authorIdentifier.getIdentifier() ) );
        }

        return xtaLookupServiceRequest.build();
    }

    @Override
    public XtaGetTransportReportRequest mapXtaGetTransportReportRequest(AttributedURIType messageId, PartyType authorIdentifier) {
        if ( messageId == null && authorIdentifier == null ) {
            return null;
        }

        XtaGetTransportReportRequest.XtaGetTransportReportRequestBuilder xtaGetTransportReportRequest = XtaGetTransportReportRequest.builder();

        if ( messageId != null ) {
            xtaGetTransportReportRequest.messageId( messageId.getValue() );
        }
        if ( authorIdentifier != null ) {
            xtaGetTransportReportRequest.clientIdentifier( mapXtaIdentifier( authorIdentifier.getIdentifier() ) );
        }

        return xtaGetTransportReportRequest.build();
    }

    private ContentType genericContainerContentContainerMessage(GenericContentContainer genericContentContainer) {
        GenericContentContainer.ContentContainer contentContainer = genericContentContainer.getContentContainer();
        if ( contentContainer == null ) {
            return null;
        }
        return contentContainer.getMessage();
    }

    private List<ContentType> genericContainerContentContainerAttachment(GenericContentContainer genericContentContainer) {
        GenericContentContainer.ContentContainer contentContainer = genericContentContainer.getContentContainer();
        if ( contentContainer == null ) {
            return null;
        }
        return contentContainer.getAttachment();
    }

    protected List<XtaFile> contentTypeListToXtaFileList(List<ContentType> list) {
        if ( list == null ) {
            return null;
        }

        List<XtaFile> list1 = new ArrayList<XtaFile>( list.size() );
        for ( ContentType contentType : list ) {
            list1.add( mapXtaFileFromContentType( contentType ) );
        }

        return list1;
    }

    private String messageMetaDataQualifierService(MessageMetaData messageMetaData) {
        QualifierType qualifier = messageMetaData.getQualifier();
        if ( qualifier == null ) {
            return null;
        }
        return qualifier.getService();
    }

    private QualifierType.BusinessScenario messageMetaDataQualifierBusinessScenario(MessageMetaData messageMetaData) {
        QualifierType qualifier = messageMetaData.getQualifier();
        if ( qualifier == null ) {
            return null;
        }
        return qualifier.getBusinessScenario();
    }

    private String messageMetaDataQualifierBusinessScenarioDefinedName(MessageMetaData messageMetaData) {
        QualifierType qualifier = messageMetaData.getQualifier();
        if ( qualifier == null ) {
            return null;
        }
        QualifierType.BusinessScenario businessScenario = qualifier.getBusinessScenario();
        if ( businessScenario == null ) {
            return null;
        }
        KeyCodeType defined = businessScenario.getDefined();
        if ( defined == null ) {
            return null;
        }
        return defined.getName();
    }

    private String messageMetaDataQualifierBusinessScenarioDefinedListURI(MessageMetaData messageMetaData) {
        QualifierType qualifier = messageMetaData.getQualifier();
        if ( qualifier == null ) {
            return null;
        }
        QualifierType.BusinessScenario businessScenario = qualifier.getBusinessScenario();
        if ( businessScenario == null ) {
            return null;
        }
        KeyCodeType defined = businessScenario.getDefined();
        if ( defined == null ) {
            return null;
        }
        return defined.getListURI();
    }

    private String messageMetaDataQualifierBusinessScenarioDefinedListVersionID(MessageMetaData messageMetaData) {
        QualifierType qualifier = messageMetaData.getQualifier();
        if ( qualifier == null ) {
            return null;
        }
        QualifierType.BusinessScenario businessScenario = qualifier.getBusinessScenario();
        if ( businessScenario == null ) {
            return null;
        }
        KeyCodeType defined = businessScenario.getDefined();
        if ( defined == null ) {
            return null;
        }
        return defined.getListVersionID();
    }

    private String messageMetaDataQualifierMessageTypeCode(MessageMetaData messageMetaData) {
        QualifierType qualifier = messageMetaData.getQualifier();
        if ( qualifier == null ) {
            return null;
        }
        QualifierType.MessageType messageType = qualifier.getMessageType();
        if ( messageType == null ) {
            return null;
        }
        return messageType.getCode();
    }

    private String messageMetaDataQualifierMessageTypePayloadSchema(MessageMetaData messageMetaData) {
        QualifierType qualifier = messageMetaData.getQualifier();
        if ( qualifier == null ) {
            return null;
        }
        QualifierType.MessageType messageType = qualifier.getMessageType();
        if ( messageType == null ) {
            return null;
        }
        return messageType.getPayloadSchema();
    }

    private String messageMetaDataMsgIdentificationMessageIDValue(MessageMetaData messageMetaData) {
        MsgIdentificationType msgIdentification = messageMetaData.getMsgIdentification();
        if ( msgIdentification == null ) {
            return null;
        }
        AttributedURIType messageID = msgIdentification.getMessageID();
        if ( messageID == null ) {
            return null;
        }
        return messageID.getValue();
    }

    private PartyIdentifierType messageMetaDataOriginatorsAuthorIdentifier(MessageMetaData messageMetaData) {
        OriginatorsType originators = messageMetaData.getOriginators();
        if ( originators == null ) {
            return null;
        }
        PartyType author = originators.getAuthor();
        if ( author == null ) {
            return null;
        }
        return author.getIdentifier();
    }

    private PartyIdentifierType messageMetaDataDestinationsReaderIdentifier(MessageMetaData messageMetaData) {
        DestinationsType destinations = messageMetaData.getDestinations();
        if ( destinations == null ) {
            return null;
        }
        PartyType reader = destinations.getReader();
        if ( reader == null ) {
            return null;
        }
        return reader.getIdentifier();
    }

    private String closeRequestLastMsgReceivedFirstValue(MsgBoxCloseRequestType msgBoxCloseRequestType) {
        List<AttributedURIType> lastMsgReceived = msgBoxCloseRequestType.getLastMsgReceived();
        if ( lastMsgReceived == null ) {
            return null;
        }
        AttributedURIType first = lastMsgReceived.getFirst();
        if ( first == null ) {
            return null;
        }
        return first.getValue();
    }

    private String fetchRequestMsgSelectorMessageIDFirstValue(MsgBoxFetchRequest msgBoxFetchRequest) {
        MsgSelector msgSelector = msgBoxFetchRequest.getMsgSelector();
        if ( msgSelector == null ) {
            return null;
        }
        List<AttributedURIType> messageID = msgSelector.getMessageID();
        if ( messageID == null ) {
            return null;
        }
        AttributedURIType first = messageID.getFirst();
        if ( first == null ) {
            return null;
        }
        return first.getValue();
    }

    private String lookupServiceRequestLookupServiceRequestListFirstLookupServiceServiceType(LookupServiceRequest lookupServiceRequest) {
        List<LookupServiceRequest.LookupServiceRequestList> lookupServiceRequestList = lookupServiceRequest.getLookupServiceRequestList();
        if ( lookupServiceRequestList == null ) {
            return null;
        }
        LookupServiceRequest.LookupServiceRequestList first = lookupServiceRequestList.getFirst();
        if ( first == null ) {
            return null;
        }
        LookupServiceType lookupService = first.getLookupService();
        if ( lookupService == null ) {
            return null;
        }
        return lookupService.getServiceType();
    }

    private PartyIdentifierType lookupServiceRequestLookupServiceRequestListFirstLookupServiceReaderIdentifier(LookupServiceRequest lookupServiceRequest) {
        List<LookupServiceRequest.LookupServiceRequestList> lookupServiceRequestList = lookupServiceRequest.getLookupServiceRequestList();
        if ( lookupServiceRequestList == null ) {
            return null;
        }
        LookupServiceRequest.LookupServiceRequestList first = lookupServiceRequestList.getFirst();
        if ( first == null ) {
            return null;
        }
        LookupServiceType lookupService = first.getLookupService();
        if ( lookupService == null ) {
            return null;
        }
        PartyType reader = lookupService.getReader();
        if ( reader == null ) {
            return null;
        }
        return reader.getIdentifier();
    }
}
