package de.ozgcloud.xta.test.app.mapper;

import de.ozgcloud.xta.test.app.model.XtaFile;
import de.ozgcloud.xta.test.app.model.XtaIdentifier;
import de.ozgcloud.xta.test.app.model.XtaLookupServiceRequest;
import de.ozgcloud.xta.test.app.model.XtaMessage;
import de.ozgcloud.xta.test.app.model.XtaMessageMetaData;
import de.ozgcloud.xta.test.app.model.XtaMessageMetaDataListing;
import de.ozgcloud.xta.test.app.model.XtaTransportReport;
import genv3.de.xoev.transport.xta.x211.ContentType;
import genv3.de.xoev.transport.xta.x211.GenericContentContainer;
import genv3.de.xoev.transport.xta.x211.IsServiceAvailableValueType;
import genv3.de.xoev.transport.xta.x211.LookupServiceResponse;
import genv3.de.xoev.transport.xta.x211.LookupServiceResultType;
import genv3.de.xoev.transport.xta.x211.MessageStatusType;
import genv3.de.xoev.transport.xta.x211.TransportReport;
import genv3.eu.osci.ws.x2008.x05.transport.MsgBoxResponseType;
import genv3.eu.osci.ws.x2008.x05.transport.MsgStatusListType;
import genv3.eu.osci.ws.x2014.x10.transport.DeliveryAttributesType;
import genv3.eu.osci.ws.x2014.x10.transport.DestinationsType;
import genv3.eu.osci.ws.x2014.x10.transport.KeyCodeType;
import genv3.eu.osci.ws.x2014.x10.transport.MessageMetaData;
import genv3.eu.osci.ws.x2014.x10.transport.MsgIdentificationType;
import genv3.eu.osci.ws.x2014.x10.transport.OriginatorsType;
import genv3.eu.osci.ws.x2014.x10.transport.PartyIdentifierType;
import genv3.eu.osci.ws.x2014.x10.transport.PartyType;
import genv3.eu.osci.ws.x2014.x10.transport.QualifierType;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import javax.annotation.processing.Generated;
import javax.xml.datatype.XMLGregorianCalendar;
import org.apache.cxf.ws.addressing.AttributedURIType;
import org.springframework.stereotype.Component;

@Generated(
    value = "org.mapstruct.ap.MappingProcessor",
    date = "2025-04-04T11:28:08+0000",
    comments = "version: 1.6.0, compiler: javac, environment: Java 21.0.6 (Eclipse Adoptium)"
)
@Component
public class ResponseMapperImpl implements ResponseMapper {

    @Override
    public MessageMetaData mapMessageMetaData(XtaMessageMetaData xtaMessageMetaData) {
        if ( xtaMessageMetaData == null ) {
            return null;
        }

        MessageMetaData messageMetaData = new MessageMetaData();

        messageMetaData.setQualifier( xtaMessageMetaDataToQualifierType( xtaMessageMetaData ) );
        messageMetaData.setMsgIdentification( xtaMessageMetaDataToMsgIdentificationType( xtaMessageMetaData ) );
        messageMetaData.setOriginators( xtaMessageMetaDataToOriginatorsType( xtaMessageMetaData ) );
        messageMetaData.setDestinations( xtaMessageMetaDataToDestinationsType( xtaMessageMetaData ) );
        if ( pendingMessagesCountIsNotZero( xtaMessageMetaData.messageSize(), "msgSize", "messageSize" ) ) {
            messageMetaData.setMsgSize( xtaMessageMetaData.messageSize() );
        }

        messageMetaData.setDeliveryAttributes( createDefaultDeliveryAttributes(createNowXmlGregorianCalendar()) );

        return messageMetaData;
    }

    @Override
    public QualifierType.BusinessScenario mapUndefinedBusinessScenario(XtaMessageMetaData xtaMessageMetaData) {
        if ( xtaMessageMetaData == null ) {
            return null;
        }

        QualifierType.BusinessScenario businessScenario = new QualifierType.BusinessScenario();

        businessScenario.setUndefined( xtaMessageMetaData.businessScenarioCode() );

        businessScenario.setDefined( null );

        return businessScenario;
    }

    @Override
    public QualifierType.BusinessScenario mapDefinedBusinessScenario(XtaMessageMetaData xtaMessageMetaData) {
        if ( xtaMessageMetaData == null ) {
            return null;
        }

        QualifierType.BusinessScenario businessScenario = new QualifierType.BusinessScenario();

        businessScenario.setDefined( mapKeyCodeType( xtaMessageMetaData ) );

        businessScenario.setUndefined( null );

        return businessScenario;
    }

    @Override
    public KeyCodeType mapKeyCodeType(XtaMessageMetaData xtaMessageMetaData) {
        if ( xtaMessageMetaData == null ) {
            return null;
        }

        KeyCodeType keyCodeType = new KeyCodeType();

        keyCodeType.setCode( xtaMessageMetaData.businessScenarioCode() );
        keyCodeType.setName( xtaMessageMetaData.businessScenarioName() );
        keyCodeType.setListURI( xtaMessageMetaData.businessScenarioListUri() );
        keyCodeType.setListVersionID( xtaMessageMetaData.businessScenarioListVersionId() );

        return keyCodeType;
    }

    @Override
    public QualifierType.MessageType mapMessageTypeQualifierType(XtaMessageMetaData xtaMessageMetaData) {
        if ( xtaMessageMetaData == null ) {
            return null;
        }

        QualifierType.MessageType messageType = new QualifierType.MessageType();

        messageType.setCode( xtaMessageMetaData.messageTypeCode() );
        messageType.setPayloadSchema( xtaMessageMetaData.messageTypePayloadSchema() );

        messageType.setListURI( "urn:de:payloadSchema:elementName" );
        messageType.setListVersionID( "1.0" );

        return messageType;
    }

    @Override
    public PartyIdentifierType mapPartyIdentifierType(XtaIdentifier value) {
        if ( value == null ) {
            return null;
        }

        PartyIdentifierType partyIdentifierType = new PartyIdentifierType();

        partyIdentifierType.setValue( value.value() );
        partyIdentifierType.setName( value.name() );
        partyIdentifierType.setCategory( value.category() );

        partyIdentifierType.setType( "xoev" );

        return partyIdentifierType;
    }

    @Override
    public GenericContentContainer mapGenericContentContainerFromXtaMessage(XtaMessage xtaMessage) {
        if ( xtaMessage == null ) {
            return null;
        }

        GenericContentContainer genericContentContainer = new GenericContentContainer();

        genericContentContainer.setContentContainer( xtaMessageToContentContainer( xtaMessage ) );

        genericContentContainer.setEncryptedData( null );

        return genericContentContainer;
    }

    @Override
    public ContentType mapContentTypeFromXtaFile(XtaFile xtaFile) {
        if ( xtaFile == null ) {
            return null;
        }

        ContentType contentType = new ContentType();

        contentType.setValue( getDataHandlerFromFile( xtaFile.file() ) );
        contentType.setFilename( xtaFile.name() );
        contentType.setLang( xtaFile.language() );
        contentType.setContentDescription( xtaFile.contentDescription() );
        contentType.setContentType( xtaFile.contentType() );
        contentType.setEncoding( xtaFile.encoding() );
        contentType.setId( xtaFile.id() );
        if ( pendingMessagesCountIsNotZero( xtaFile.size(), "size", "size" ) ) {
            contentType.setSize( xtaFile.size() );
        }

        return contentType;
    }

    @Override
    public DeliveryAttributesType createDefaultDeliveryAttributes(XMLGregorianCalendar timestamp) {
        if ( timestamp == null ) {
            return null;
        }

        DeliveryAttributesType deliveryAttributesType = new DeliveryAttributesType();

        deliveryAttributesType.setDelivery( timestamp );
        deliveryAttributesType.setInitialFetch( timestamp );
        deliveryAttributesType.setInitialSend( timestamp );
        deliveryAttributesType.setOrigin( timestamp );

        return deliveryAttributesType;
    }

    @Override
    public MsgBoxResponseType mapMsgBoxResponseTypeFromRequestId(String requestId) {
        if ( requestId == null ) {
            return null;
        }

        MsgBoxResponseType msgBoxResponseType = new MsgBoxResponseType();

        msgBoxResponseType.setMsgBoxRequestID( requestId );

        msgBoxResponseType.setItemsPending( BigInteger.ZERO );
        msgBoxResponseType.setNoMessageAvailable( null );

        return msgBoxResponseType;
    }

    @Override
    public MsgBoxResponseType mapMsgBoxResponseType(XtaMessageMetaDataListing listing) {
        if ( listing == null ) {
            return null;
        }

        MsgBoxResponseType msgBoxResponseType = new MsgBoxResponseType();

        if ( pendingMessagesCountIsNotZero( listing.pendingMessageCount(), "itemsPending", "pendingMessageCount" ) ) {
            msgBoxResponseType.setItemsPending( listing.pendingMessageCount() );
        }
        msgBoxResponseType.setNoMessageAvailable( mapNoMessageAvailableReason( listing.messages() ) );

        msgBoxResponseType.setMsgBoxRequestID( "1" );

        return msgBoxResponseType;
    }

    @Override
    public MsgBoxResponseType.NoMessageAvailable createNoMessageAvailableWithReason(String reason) {
        if ( reason == null ) {
            return null;
        }

        MsgBoxResponseType.NoMessageAvailable noMessageAvailable = new MsgBoxResponseType.NoMessageAvailable();

        noMessageAvailable.setReason( reason );

        return noMessageAvailable;
    }

    @Override
    public MsgStatusListType mapMsgStatusListType(XtaMessageMetaDataListing listing) {
        if ( listing == null ) {
            return null;
        }

        MsgStatusListType msgStatusListType = new MsgStatusListType();

        if ( msgStatusListType.getMessageMetaData() != null ) {
            List<MessageMetaData> list = xtaMessageMetaDataListToMessageMetaDataList( listing.messages() );
            if ( list != null ) {
                msgStatusListType.getMessageMetaData().addAll( list );
            }
        }

        return msgStatusListType;
    }

    @Override
    public MsgBoxResponseType mapMsgBoxResponseTypeError(String errorString) {
        if ( errorString == null ) {
            return null;
        }

        MsgBoxResponseType msgBoxResponseType = new MsgBoxResponseType();

        msgBoxResponseType.setNoMessageAvailable( stringToNoMessageAvailable( errorString ) );

        msgBoxResponseType.setMsgBoxRequestID( "1" );

        return msgBoxResponseType;
    }

    @Override
    public LookupServiceResultType mapLookupServiceResultType(XtaLookupServiceRequest xtaLookupServiceRequest) {
        if ( xtaLookupServiceRequest == null ) {
            return null;
        }

        LookupServiceResultType lookupServiceResultType = new LookupServiceResultType();

        lookupServiceResultType.setReader( xtaLookupServiceRequestToPartyType( xtaLookupServiceRequest ) );
        lookupServiceResultType.setServiceType( xtaLookupServiceRequest.service() );
        lookupServiceResultType.setIsServiceAvailableValue( xtaLookupServiceRequestToIsServiceAvailableValueType( xtaLookupServiceRequest ) );

        return lookupServiceResultType;
    }

    @Override
    public LookupServiceResponse mapLookupServiceResponse(XtaLookupServiceRequest xtaLookupServiceRequest) {
        if ( xtaLookupServiceRequest == null ) {
            return null;
        }

        LookupServiceResponse lookupServiceResponse = new LookupServiceResponse();

        lookupServiceResponse.setLookupServiceResultList( xtaLookupServiceRequestToLookupServiceResultList( xtaLookupServiceRequest ) );

        return lookupServiceResponse;
    }

    @Override
    public TransportReport mapTransportReport(XtaTransportReport xtaTransportReport) {
        if ( xtaTransportReport == null ) {
            return null;
        }

        TransportReport transportReport = new TransportReport();

        transportReport.setMessageMetaData( mapMessageMetaData( xtaTransportReport.messageMetaData() ) );
        transportReport.setReportTime( mapXmlGregorianCalendarFromZonedDateTime( xtaTransportReport.reportTime() ) );
        transportReport.setMessageStatus( xtaTransportReportToMessageStatusType( xtaTransportReport ) );

        transportReport.setXTAServerIdentity( "xta-test-server" );

        return transportReport;
    }

    @Override
    public AttributedURIType mapCreateMessageIdResponse(String value) {
        if ( value == null ) {
            return null;
        }

        AttributedURIType attributedURIType = new AttributedURIType();

        attributedURIType.setValue( value );

        return attributedURIType;
    }

    protected QualifierType xtaMessageMetaDataToQualifierType(XtaMessageMetaData xtaMessageMetaData) {
        if ( xtaMessageMetaData == null ) {
            return null;
        }

        QualifierType qualifierType = new QualifierType();

        qualifierType.setService( xtaMessageMetaData.service() );
        qualifierType.setBusinessScenario( mapBusinessScenario( xtaMessageMetaData ) );
        qualifierType.setMessageType( mapMessageTypeQualifierType( xtaMessageMetaData ) );

        return qualifierType;
    }

    protected AttributedURIType xtaMessageMetaDataToAttributedURIType(XtaMessageMetaData xtaMessageMetaData) {
        if ( xtaMessageMetaData == null ) {
            return null;
        }

        AttributedURIType attributedURIType = new AttributedURIType();

        attributedURIType.setValue( xtaMessageMetaData.messageId() );

        return attributedURIType;
    }

    protected MsgIdentificationType xtaMessageMetaDataToMsgIdentificationType(XtaMessageMetaData xtaMessageMetaData) {
        if ( xtaMessageMetaData == null ) {
            return null;
        }

        MsgIdentificationType msgIdentificationType = new MsgIdentificationType();

        msgIdentificationType.setMessageID( xtaMessageMetaDataToAttributedURIType( xtaMessageMetaData ) );

        return msgIdentificationType;
    }

    protected PartyType xtaMessageMetaDataToPartyType(XtaMessageMetaData xtaMessageMetaData) {
        if ( xtaMessageMetaData == null ) {
            return null;
        }

        PartyType partyType = new PartyType();

        partyType.setIdentifier( mapPartyIdentifierType( xtaMessageMetaData.authorIdentifier() ) );

        return partyType;
    }

    protected PartyType xtaMessageMetaDataToPartyType1(XtaMessageMetaData xtaMessageMetaData) {
        if ( xtaMessageMetaData == null ) {
            return null;
        }

        PartyType partyType = new PartyType();

        partyType.setIdentifier( mapPartyIdentifierType(SENDER_IDENTIFIER) );

        return partyType;
    }

    protected OriginatorsType xtaMessageMetaDataToOriginatorsType(XtaMessageMetaData xtaMessageMetaData) {
        if ( xtaMessageMetaData == null ) {
            return null;
        }

        OriginatorsType originatorsType = new OriginatorsType();

        originatorsType.setAuthor( xtaMessageMetaDataToPartyType( xtaMessageMetaData ) );
        originatorsType.setSender( xtaMessageMetaDataToPartyType1( xtaMessageMetaData ) );

        return originatorsType;
    }

    protected PartyType xtaMessageMetaDataToPartyType2(XtaMessageMetaData xtaMessageMetaData) {
        if ( xtaMessageMetaData == null ) {
            return null;
        }

        PartyType partyType = new PartyType();

        partyType.setIdentifier( mapPartyIdentifierType( xtaMessageMetaData.readerIdentifier() ) );

        return partyType;
    }

    protected DestinationsType xtaMessageMetaDataToDestinationsType(XtaMessageMetaData xtaMessageMetaData) {
        if ( xtaMessageMetaData == null ) {
            return null;
        }

        DestinationsType destinationsType = new DestinationsType();

        destinationsType.setReader( xtaMessageMetaDataToPartyType2( xtaMessageMetaData ) );

        return destinationsType;
    }

    protected List<ContentType> xtaFileListToContentTypeList(List<XtaFile> list) {
        if ( list == null ) {
            return null;
        }

        List<ContentType> list1 = new ArrayList<ContentType>( list.size() );
        for ( XtaFile xtaFile : list ) {
            list1.add( mapContentTypeFromXtaFile( xtaFile ) );
        }

        return list1;
    }

    protected GenericContentContainer.ContentContainer xtaMessageToContentContainer(XtaMessage xtaMessage) {
        if ( xtaMessage == null ) {
            return null;
        }

        GenericContentContainer.ContentContainer contentContainer = new GenericContentContainer.ContentContainer();

        contentContainer.setMessage( mapContentTypeFromXtaFile( xtaMessage.messageFile() ) );
        if ( contentContainer.getAttachment() != null ) {
            List<ContentType> list = xtaFileListToContentTypeList( xtaMessage.attachmentFiles() );
            if ( list != null ) {
                contentContainer.getAttachment().addAll( list );
            }
        }

        return contentContainer;
    }

    protected List<MessageMetaData> xtaMessageMetaDataListToMessageMetaDataList(List<XtaMessageMetaData> list) {
        if ( list == null ) {
            return null;
        }

        List<MessageMetaData> list1 = new ArrayList<MessageMetaData>( list.size() );
        for ( XtaMessageMetaData xtaMessageMetaData : list ) {
            list1.add( mapMessageMetaData( xtaMessageMetaData ) );
        }

        return list1;
    }

    protected MsgBoxResponseType.NoMessageAvailable stringToNoMessageAvailable(String string) {
        if ( string == null ) {
            return null;
        }

        MsgBoxResponseType.NoMessageAvailable noMessageAvailable = new MsgBoxResponseType.NoMessageAvailable();

        noMessageAvailable.setReason( string );

        return noMessageAvailable;
    }

    protected PartyType xtaLookupServiceRequestToPartyType(XtaLookupServiceRequest xtaLookupServiceRequest) {
        if ( xtaLookupServiceRequest == null ) {
            return null;
        }

        PartyType partyType = new PartyType();

        partyType.setIdentifier( mapPartyIdentifierType( xtaLookupServiceRequest.readerIdentifier() ) );

        return partyType;
    }

    protected IsServiceAvailableValueType xtaLookupServiceRequestToIsServiceAvailableValueType(XtaLookupServiceRequest xtaLookupServiceRequest) {
        if ( xtaLookupServiceRequest == null ) {
            return null;
        }

        IsServiceAvailableValueType isServiceAvailableValueType = new IsServiceAvailableValueType();

        isServiceAvailableValueType.setServiceIsAvailable( true );

        return isServiceAvailableValueType;
    }

    protected LookupServiceResponse.LookupServiceResultList xtaLookupServiceRequestToLookupServiceResultList(XtaLookupServiceRequest xtaLookupServiceRequest) {
        if ( xtaLookupServiceRequest == null ) {
            return null;
        }

        LookupServiceResponse.LookupServiceResultList lookupServiceResultList = new LookupServiceResponse.LookupServiceResultList();

        if ( lookupServiceResultList.getLookupServiceResult() != null ) {
            List<LookupServiceResultType> list = List.of( mapLookupServiceResultType(xtaLookupServiceRequest) );
            if ( list != null ) {
                lookupServiceResultList.getLookupServiceResult().addAll( list );
            }
        }

        return lookupServiceResultList;
    }

    protected MessageStatusType xtaTransportReportToMessageStatusType(XtaTransportReport xtaTransportReport) {
        if ( xtaTransportReport == null ) {
            return null;
        }

        MessageStatusType messageStatusType = new MessageStatusType();

        messageStatusType.setStatus( BigInteger.valueOf(xtaTransportReport.status().ordinal()) );

        return messageStatusType;
    }
}
