package de.ozgcloud.xta.test.app.model;

import java.io.File;
import java.math.BigInteger;

import jakarta.annotation.Nullable;
import jakarta.validation.constraints.NotBlank;
import jakarta.validation.constraints.NotNull;
import jakarta.validation.constraints.PositiveOrZero;

import lombok.Builder;

@Builder
public record XtaFile(
		@NotNull File file,
		@NotBlank String contentType,
		@Nullable String contentDescription,
		@Nullable String encoding,
		@NotBlank String name,
		@Nullable String id,
		@Nullable String language,
		@PositiveOrZero BigInteger size
) {
}
