package de.ozgcloud.xta.test.app.model;

import static de.ozgcloud.xta.test.app.validation.ValidXtaId.*;

import java.math.BigInteger;

import jakarta.annotation.Nullable;
import jakarta.validation.Valid;
import jakarta.validation.constraints.NotBlank;
import jakarta.validation.constraints.NotNull;
import jakarta.validation.constraints.PositiveOrZero;

import de.ozgcloud.xta.test.app.validation.ValidXtaId;
import lombok.Builder;

@Builder(toBuilder = true)
public record XtaMessageMetaData(
		@NotBlank String service,
		@NotBlank String businessScenarioCode,
		@Nullable String businessScenarioName,
		@Nullable String businessScenarioListUri,
		@Nullable String businessScenarioListVersionId,
		@NotBlank String messageTypeCode,
		@NotBlank String messageTypePayloadSchema,
		@ValidXtaId(namespace = MESSAGE_ID_NAMESPACE) String messageId,
		@NotNull @Valid XtaIdentifier authorIdentifier,
		@NotNull @Valid XtaIdentifier readerIdentifier,
		@PositiveOrZero BigInteger messageSize
) {
}
