package de.ozgcloud.xta.test.app.validation;

import java.util.regex.Pattern;

import jakarta.validation.ConstraintValidator;
import jakarta.validation.ConstraintValidatorContext;

public class XtaIdValidator implements ConstraintValidator<ValidXtaId, String> {

	private Pattern pattern;

	@Override
	public void initialize(ValidXtaId constraintAnnotation) {
		pattern = Pattern.compile(
				"(\\w+):(" + constraintAnnotation.namespace() + "):([^:]+):([^:]+)"
		);
	}

	@Override
	public boolean isValid(String value, ConstraintValidatorContext constraintValidatorContext) {
		return value != null && pattern.matcher(value).matches();
	}
}
